-------------------------------------------------------------------------------------------
--                    Les tables completes en lecture seule                              --
-------------------------------------------------------------------------------------------

-------------------------------------------------------------------------------------------
-- Structure de la table Arme
--

DROP TABLE Arme;
CREATE TABLE Arme (
  cArme CHAR(3) NOT NULL PRIMARY KEY,
  nom TEXT NOT NULL UNIQUE,
  categorie INTEGER default 1,
  degatMin INTEGER NOT NULL default 0,
  degatDe INTEGER NOT NULL default 0,
  solidite INTEGER default NULL,
  prix INTEGER default NULL,
  poids INTEGER NOT NULL default 0,
  nivExp INTEGER NOT NULL default 1
);

--
-- Contenu de la table Arme
--

INSERT INTO Arme VALUES ('GOU','gourdin',             1, 1,  8,  6,  2,  2,  1);
INSERT INTO Arme VALUES ('BAT','baton',               2, 2,  8,  5,  2,  2,  1);
INSERT INTO Arme VALUES ('DAG','dague',               1, 3,  5,  8,  8,  2,  1);
INSERT INTO Arme VALUES ('ECO','epee courte',         1, 4,  8,  10, 10, 3,  1);
INSERT INTO Arme VALUES ('E2M','epee a 2 mains',      2, 8,  16, 15, 30, 6,  2);
INSERT INTO Arme VALUES ('HAC','hache',               1, 6,  4,  11, 10, 4,  1);
INSERT INTO Arme VALUES ('HAG','hache de guerre',     2, 12, 10, 8,  35, 8,  2);
INSERT INTO Arme VALUES ('ACO','arc court',           2, 6,  6,  9,  15, 2,  1);
INSERT INTO Arme VALUES ('ALO','arc long',            2, 8,  10, 13, 30, 3,  2);
INSERT INTO Arme VALUES ('ARB','arbalette',           2, 8,  18, 20, 40, 5,  2);
INSERT INTO Arme VALUES ('MAG','marteau de guerre',   2, 12, 18, 22, 50, 10, 3);
INSERT INTO Arme VALUES ('CIM','cimeterre de crital', 1, 10, 18, 15, 70, 5,  3);
INSERT INTO Arme VALUES ('AFE','arc de feu',          2, 8,  24, 15, 50, 4,  3);

-------------------------------------------------------------------------------------------
-- Structure de la table ArmeCac
--

DROP TABLE ArmeCac;
CREATE TABLE ArmeCac (
  cArme CHAR(3) NOT NULL PRIMARY KEY,
  FOREIGN KEY  (cArme) REFERENCES Arme 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Contenu de la table ArmeCac
--

INSERT INTO ArmeCac VALUES ('GOU');
INSERT INTO ArmeCac VALUES ('BAT');
INSERT INTO ArmeCac VALUES ('DAG');
INSERT INTO ArmeCac VALUES ('ECO');
INSERT INTO ArmeCac VALUES ('E2M');
INSERT INTO ArmeCac VALUES ('HAC');
INSERT INTO ArmeCac VALUES ('HAG');
INSERT INTO ArmeCac VALUES ('MAG');
INSERT INTO ArmeCac VALUES ('CIM');

-------------------------------------------------------------------------------------------
-- Structure de la table ArmeTir
--

DROP TABLE ArmeTir;
CREATE TABLE ArmeTir (
  cArme CHAR(3) NOT NULL PRIMARY KEY,
  FOREIGN KEY  (cArme) REFERENCES Arme 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Contenu de la table ArmeTir
--

INSERT INTO ArmeTir VALUES ('ACO');
INSERT INTO ArmeTir VALUES ('ALO');
INSERT INTO ArmeTir VALUES ('ARB');
INSERT INTO ArmeTir VALUES ('AFE');

-------------------------------------------------------------------------------------------
-- Structure de la table Armure
--

DROP TABLE Armure;
CREATE TABLE Armure (
  cArmure CHAR(3) NOT NULL PRIMARY KEY,
  nom TEXT NOT NULL UNIQUE,
  protection INTEGER NOT NULL default 0,
  solidite INTEGER default NULL,
  prix INTEGER default NULL,
  poids INTEGER NOT NULL default 0,
  nivExp INTEGER NOT NULL default 1
);

--
-- Contenu de la table Armure
--

INSERT INTO Armure VALUES ('TIS','tissus rembourre', 1,  5,  8,   1,  1);
INSERT INTO Armure VALUES ('CUI','cuir',             2,  7,  15,  3,  1);
INSERT INTO Armure VALUES ('CME','cuir metal',       3,  10, 35,  6,  1);
INSERT INTO Armure VALUES ('MET','metal',            5,  15, 80,  15, 2);
INSERT INTO Armure VALUES ('DIA','diamant',          10, 40, 500, 25, 3);

----------------------------------------------------------------------------------------
-- Structure de la table Bouclier
--

DROP TABLE Bouclier;
CREATE TABLE Bouclier (
  cBouclier CHAR(3) NOT NULL PRIMARY KEY,
  nom TEXT NOT NULL UNIQUE,
  protection INTEGER NOT NULL default 0,
  solidite INTEGER default NULL,
  prix INTEGER default NULL,
  poids INTEGER NOT NULL default 0,
  nivExp INTEGER NOT NULL default 1
);

--
-- Contenu de la table Bouclier
--

INSERT INTO Bouclier VALUES ('BRO','bois rond',           3,  4,  10,   2, 1);
INSERT INTO Bouclier VALUES ('BRE','bois rectangle haut', 6,  4,  25,   6, 1);
INSERT INTO Bouclier VALUES ('FRO','fer rond',            4, 13,  16,   4, 1);
INSERT INTO Bouclier VALUES ('FRE','fer rectangle haut',  7, 13,  42,  12, 2);
INSERT INTO Bouclier VALUES ('EOV','emeraude oval',       8, 30,  100, 15, 3);

-----------------------------------------------------------------------------------------
-- Structure de la table Casque
--

DROP TABLE Casque;
CREATE TABLE Casque (
  cCasque CHAR(3) NOT NULL PRIMARY KEY,
  nom TEXT NOT NULL UNIQUE,
  protection INTEGER NOT NULL default 0,
  solidite INTEGER default NULL,
  prix INTEGER default NULL,
  poids INTEGER NOT NULL default 0,
  nivExp INTEGER NOT NULL default 1
);

--
-- Contenu de la table Casque
--

INSERT INTO Casque VALUES ('CHA','chapeau rembourre', 1,  4,  4,  1,  1);
INSERT INTO Casque VALUES ('COU','couronne',          2,  6,  8,  2,  1);
INSERT INTO Casque VALUES ('HAU','haume',             4, 10, 15,  3,  1);
INSERT INTO Casque VALUES ('HIN','haume integral',    5, 13, 20,  4,  2);

-----------------------------------------------------------------------------------------
-- Structure de la table Potion
--

DROP TABLE Potion;
CREATE TABLE Potion (
  cPotion CHAR(3) NOT NULL PRIMARY KEY,
  nom TEXT NOT NULL UNIQUE,
  prix INTEGER default NULL,
  poids INTEGER NOT NULL default 0,
  nivExp INTEGER NOT NULL default 1
);

--
-- Contenu de la table Potion
--

INSERT INTO Potion VALUES ('PFV','petite fiole de vie',       2, 0, 1);
INSERT INTO Potion VALUES ('MFV','fiole de vie',              6, 0, 1);
INSERT INTO Potion VALUES ('GFV','grande fiole de vie',      18, 1, 1);
INSERT INTO Potion VALUES ('PFM','petite fiole de magie',     2, 0, 1);
INSERT INTO Potion VALUES ('MFM','fiole de magie',            6, 0, 1);
INSERT INTO Potion VALUES ('GFM','grande fiole de magie',    18, 1, 1);
INSERT INTO Potion VALUES ('PFJ','petite fiole de jouvance',  5, 0, 1);
INSERT INTO Potion VALUES ('MFJ','fiole de jouvance',        15, 0, 1);
INSERT INTO Potion VALUES ('GFJ','grande fiole de jouvance', 45, 1, 1);
INSERT INTO Potion VALUES ('EDE','fiole de dexterite',      120, 0, 2);
INSERT INTO Potion VALUES ('EFO','fiole de force',          120, 0, 2);
INSERT INTO Potion VALUES ('EEN','fiole d endurance',       120, 0, 2);

----------------------------------------------------------------------------------------
-- Structure de la table PotionRegeneration
--

DROP TABLE PotionRegeneration;
CREATE TABLE PotionRegeneration (
  cPotion CHAR(3) NOT NULL PRIMARY KEY,
  pVie INTEGER NOT NULL default 0,
  pMagie INTEGER NOT NULL default 0,
  FOREIGN KEY  (cPotion) REFERENCES Potion(cPotion) 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Contenu de la table PotionRegeneration
--

INSERT INTO PotionRegeneration VALUES ('PFV',  7,  0);
INSERT INTO PotionRegeneration VALUES ('MFV', 15,  0);
INSERT INTO PotionRegeneration VALUES ('GFV', 32,  0);
INSERT INTO PotionRegeneration VALUES ('PFM',  0,  7);
INSERT INTO PotionRegeneration VALUES ('MFM',  0, 15);
INSERT INTO PotionRegeneration VALUES ('GFM',  0, 32);
INSERT INTO PotionRegeneration VALUES ('PFJ',  7,  7);
INSERT INTO PotionRegeneration VALUES ('MFJ', 15, 15);
INSERT INTO PotionRegeneration VALUES ('GFJ', 32, 32);

------------------------------------------------------------------------------------------
-- Structure de la table PotionAmelioration
--

DROP TABLE PotionAmelioration;
CREATE TABLE PotionAmelioration (
  cPotion CHAR(3) NOT NULL PRIMARY KEY,
  endurance INTEGER NOT NULL default 0,
  dexterite INTEGER NOT NULL default 0,
  force INTEGER NOT NULL default 0,
  FOREIGN KEY  (cPotion) REFERENCES Potion(cPotion) 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Contenu de la table PotionAmelioration
--

INSERT INTO PotionAmelioration VALUES ('EFO',  0,  0,  1);
INSERT INTO PotionAmelioration VALUES ('EEN',  1,  0,  0);
INSERT INTO PotionAmelioration VALUES ('EDE',  0,  1,  0);

----------------------------------------------------------------------------------------
-- Structure de la table Sort
--

DROP TABLE Sort;
CREATE TABLE Sort (
  cSort CHAR(3) NOT NULL,
  niveau INTEGER NOT NULL default 1,
  nom TEXT NOT NULL UNIQUE,
  cout INTEGER NOT NULL default 0,
  PRIMARY KEY  (cSort,niveau)
);

--
-- Contenu de la table SortSoin
--

INSERT INTO Sort VALUES ('SOI',  1,  'soin 1',     4);
INSERT INTO Sort VALUES ('SOI',  2,  'soin 2',     8);
INSERT INTO Sort VALUES ('SOI',  3,  'soin 3',    18);
INSERT INTO Sort VALUES ('SOI',  4,  'soin max',  40);
INSERT INTO Sort VALUES ('FEU',  1,  'feu 1',      2);
INSERT INTO Sort VALUES ('FEU',  2,  'feu 2',      5);
INSERT INTO Sort VALUES ('FEU',  3,  'feu 3',     12);
INSERT INTO Sort VALUES ('ECL',  1,  'eclaire 1',  2);
INSERT INTO Sort VALUES ('ECL',  2,  'eclaire 2',  5);
INSERT INTO Sort VALUES ('ECL',  3,  'eclaire 3', 12);

----------------------------------------------------------------------------------------
-- Structure de la table SortSoin
--

DROP TABLE SortSoin;
CREATE TABLE SortSoin (
  cSort CHAR(3) NOT NULL,
  niveau INTEGER NOT NULL default 1,
  regMin INTEGER NOT NULL default 0,
  regDe INTEGER NOT NULL default 0,
  PRIMARY KEY  (cSort,niveau),
  FOREIGN KEY  (cSort,niveau) REFERENCES Sort(cSort,niveau) 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Contenu de la table SortSoin
--

INSERT INTO SortSoin VALUES ('SOI',  1,   2,  5);
INSERT INTO SortSoin VALUES ('SOI',  2,   5, 10);
INSERT INTO SortSoin VALUES ('SOI',  3,  10, 25);
INSERT INTO SortSoin VALUES ('SOI',  4, 100,  0);

----------------------------------------------------------------------------------------
-- Structure de la table SortAttaque
--

DROP TABLE SortAttaque;
CREATE TABLE SortAttaque (
  cSort CHAR(3) NOT NULL,
  niveau INTEGER NOT NULL default 1,
  degatMin INTEGER NOT NULL default 0,
  degatDe INTEGER NOT NULL default 0,
  PRIMARY KEY  (cSort,niveau),
  FOREIGN KEY  (cSort,niveau) REFERENCES Sort(cSort,niveau) 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Contenu de la table SortAttaque
-- 

INSERT INTO SortAttaque VALUES ('FEU',  1,  2,  6);
INSERT INTO SortAttaque VALUES ('FEU',  2,  4, 11);
INSERT INTO SortAttaque VALUES ('FEU',  3,  9, 21);
INSERT INTO SortAttaque VALUES ('ECL',  1,  3,  4);
INSERT INTO SortAttaque VALUES ('ECL',  2,  6,  6);
INSERT INTO SortAttaque VALUES ('ECL',  3, 12, 12);

----------------------------------------------------------------------------------------
-- Structure de la table Livre
--

DROP TABLE Livre;
CREATE TABLE Livre (
  cLivre CHAR(3) NOT NULL PRIMARY KEY,
  nom TEXT NOT NULL UNIQUE,
  cSort CHAR(3) NOT NULL,
  niveau INTEGER NOT NULL default 1,
  prix INTEGER default NULL,
  poids INTEGER NOT NULL default 0,
  nivExp INTEGER NOT NULL default 1,
  FOREIGN KEY  (cSort,niveau) REFERENCES Sort(cSort,niveau) 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Contenu de la table Livre
--

INSERT INTO Livre VALUES ('LS1', 'livre de soin: initiation',         'SOI',  1,  14,  2,  1);
INSERT INTO Livre VALUES ('LS2', 'livre de soin: perfectionnement',   'SOI',  2,  25,  2,  1);
INSERT INTO Livre VALUES ('LS3', 'livre de soin: confirmation',       'SOI',  3,  50,  2,  2);
INSERT INTO Livre VALUES ('LSM', 'livre de soin: excellence',         'SOI',  4, 100,  2,  3);
INSERT INTO Livre VALUES ('LF1', 'livre de feu: initiation',          'FEU',  1,   8,  2,  1);
INSERT INTO Livre VALUES ('LF2', 'livre de feu: perfectionnement',    'FEU',  2,  25,  2,  1);
INSERT INTO Livre VALUES ('LF3', 'livre de feu: confirmation',        'FEU',  3,  50,  2,  2);
INSERT INTO Livre VALUES ('LE1', 'livre d eclaire: initiation',       'ECL',  1,   8,  2,  1);
INSERT INTO Livre VALUES ('LE2', 'livre d eclaire: perfectionnement', 'ECL',  2,  25,  2,  1);
INSERT INTO Livre VALUES ('LE3', 'livre d eclaire: confirmation',     'ECL',  3,  50,  2,  2);

----------------------------------------------------------------------------------------
-- Structure de la table Race
--

DROP TABLE Race;
CREATE TABLE Race (
  cRace CHAR(3) NOT NULL PRIMARY KEY,
  nom TEXT NOT NULL UNIQUE,
  bonusIntelligence INTEGER NOT NULL default 0,
  bonusVivacite INTEGER NOT NULL default 0,
  bonusForce INTEGER NOT NULL default 0,
  bonusEndurance INTEGER NOT NULL default 0,
  bonusDexterite INTEGER NOT NULL default 0
);

--
-- Contenu de la table Race
--

INSERT INTO Race VALUES ('NAI', 'nain',   0, 0, 1,  1, -1);
INSERT INTO Race VALUES ('ELF', 'elf',    0, 1, 0, -1,  1);
INSERT INTO Race VALUES ('HUM', 'humain', 1, 0, 0,  0,  0);

----------------------------------------------------------------------------------------
-- Structure de la table Metier
--

DROP TABLE Metier;
CREATE TABLE Metier (
  cMetier CHAR(3) NOT NULL PRIMARY KEY,
  nom TEXT NOT NULL UNIQUE,
  bonusTir INTEGER NOT NULL default 0,
  bonusVol INTEGER NOT NULL default 0,
  bonusCac INTEGER NOT NULL default 0,
  bonusPM INTEGER NOT NULL default 0,
  objetA CHAR(3) default NULL,
  objetB CHAR(3) default NULL
);

--
-- Contenu de la table Metier
--

INSERT INTO Metier VALUES ('GUE', 'guerrier',  0, 0, 2,  0, 'BRO', 'ECO');
INSERT INTO Metier VALUES ('ARC', 'archer',    2, 0, 0,  0, 'TIS', 'ACO');
INSERT INTO Metier VALUES ('VOL', 'voleur',    0, 2, 0,  0, 'TIS', 'DAG');
INSERT INTO Metier VALUES ('MGC', 'magicien',  0, 0, 0, 20, 'LS1', 'LF1');

----------------------------------------------------------------------------------------
-- Structure de la table Monstre
--

DROP TABLE Monstre;
CREATE TABLE Monstre (
  cMonstre CHAR(3) NOT NULL PRIMARY KEY,
  nom TEXT NOT NULL UNIQUE,
  nivExp INTEGER NOT NULL default 1,
  pVie INTEGER NOT NULL default 0,
  dexterite INTEGER NOT NULL default 0,
  force INTEGER NOT NULL default 0,
  vivacite INTEGER NOT NULL default 0,
  arme CHAR(3) default NULL,
  armure CHAR(3) default NULL,
  bouclier CHAR(3) default NULL,
  casque CHAR(3) default NULL,
  bourse INTEGER NOT NULL default 0,
  pExp INTEGER NOT NULL default 0,
  combat INTEGER NOT NULL default 0,
  FOREIGN KEY  (arme) REFERENCES Arme(cArme) 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (armure) REFERENCES Armure(cArmure) 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (bouclier) REFERENCES Bouclier(cBouclier) 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (casque) REFERENCES Casque(cCasque) 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Fonctions et trigger associe  la table Monstre
--

-- (dexterite,force) -> combat
DROP FUNCTION combat_proc();
CREATE FUNCTION combat_proc() RETURNS opaque 
AS '
  BEGIN
    UPDATE Monstre SET combat=dexterite+force WHERE cMonstre=NEW.cMonstre;
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER combat_trig
  AFTER INSERT ON Monstre
  FOR EACH ROW
    EXECUTE PROCEDURE combat_proc();

--
-- Contenu de la table Monstre
--

INSERT INTO Monstre VALUES ('MVO', 'voleur',               1, 15, 17, 10, 15,  'DAG',  'TIS',  NULL,   NULL,  6,  14);
INSERT INTO Monstre VALUES ('BAR', 'barbare des steppes',  2, 22, 14, 18, 15,  'HAC',  'CUI', 'BRE',   NULL,  3,  30);
INSERT INTO Monstre VALUES ('GOB', 'gobelin',              1, 20, 10, 16,  9,  'GOU',   NULL, 'BRO',   NULL,  2,  13);
INSERT INTO Monstre VALUES ('ORC', 'orc',                  2, 25, 11, 22, 12,  'ECO',   NULL, 'FRO',   NULL,  3,  35);
INSERT INTO Monstre VALUES ('TRO', 'troll',                2, 35, 12, 28, 13,  'HAG',  'CME',  NULL,   NULL,  4,  45);
INSERT INTO Monstre VALUES ('ELE', 'elemental',            2, 70, 10, 48, 12,   NULL,   NULL,  NULL,   NULL,  0,  25);
INSERT INTO Monstre VALUES ('MOR', 'mort vivant',          2, 30,  9, 20,  9,  'ECO',   NULL,  NULL,   NULL,  3,  30);
INSERT INTO Monstre VALUES ('SQU', 'squelette',            1, 10, 12, 12, 12,   NULL,   NULL,  NULL,   NULL,  4,   9);
INSERT INTO Monstre VALUES ('SQA', 'squelette arme',       1, 10, 13, 12, 12,  'ECO',   NULL, 'BRO',  'COU',  2,  21);
INSERT INTO Monstre VALUES ('TIG', 'tigre dent de sabre',  1, 15, 22, 24, 20,   NULL,   NULL,  NULL,   NULL,  0,  15);
INSERT INTO Monstre VALUES ('LOU', 'loup enrage',          1, 12, 16, 20, 17,   NULL,   NULL,  NULL,   NULL,  0,  13);
INSERT INTO Monstre VALUES ('OUR', 'ours',                 1, 25,  9, 28, 15,   NULL,   NULL,  NULL,   NULL,  0,  12);
INSERT INTO Monstre VALUES ('RAT', 'rat geant',            1,  7, 12,  9, 12,   NULL,   NULL,  NULL,   NULL,  0,   5);
INSERT INTO Monstre VALUES ('GUN', 'guerrier noir',        3, 40, 16, 20, 18,  'CIM',  'MET', 'FRE',  'HIN', 10,  85);
INSERT INTO Monstre VALUES ('ARN', 'archer noir',          3, 30, 18, 16, 17,  'AFE',  'MET',  NULL,  'HIN',  6,  70);
INSERT INTO Monstre VALUES ('ORE', 'orc d ellite',         3, 35, 13, 28, 15,  'ECO',  'CME', 'FRE',  'HAU',  4,  55);
INSERT INTO Monstre VALUES ('TRE', 'troll d ellite',       3, 50, 15, 32, 16,  'MAG',  'CME',  NULL,  'HAU',  5,  80);

----------------------------------------------------------------------------------------
-- Structure de la vue CategorieObjet
--

DROP VIEW CategorieObjet;
CREATE VIEW CategorieObjet(cObjet, cat, niv) AS
  SELECT cArme, 'ATT_A', nivExp FROM Arme
    UNION
  SELECT cArmure, 'DEF_A', nivExp FROM Armure
    UNION
  SELECT cBouclier, 'DEF_B', nivExp FROM Bouclier
    UNION
  SELECT cCasque, 'DEF_C', nivExp FROM Casque
    UNION
  SELECT cPotion, 'DIV_P', nivExp FROM Potion
    UNION
  SELECT cLivre, 'DIV_L', nivExp FROM Livre
;

-- Verifie si 2 objets ont le mme code
-- SELECT cObjet,nb FROM (SELECT cObjet,COUNT(cObjet) AS nb FROM CategorieObjet GROUP BY cObjet) AS T WHERE nb > 1;

----------------------------------------------------------------------------------------
--                Table remplie au debut d'une nouvelle partie                        --
--                    mais jamais modifiee en cours de jeu                            --
----------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------
-- Structure de la table Position
--

DROP TABLE Position;
CREATE TABLE Position (
  posX INTEGER NOT NULL,
  posY INTEGER NOT NULL,
  perso TEXT NOT NULL,
  civilisation INTEGER NOT NULL default 5,
  PRIMARY KEY (posX,posY,perso)
 );

--
-- Fonctions et trigger associe  la table Position
--

-- Verifie que l'attribut perso contient un perso existant
DROP FUNCTION check_perso_position_proc();
CREATE FUNCTION check_perso_position_proc() RETURNS opaque 
AS '
  DECLARE
    reponse INTEGER;
  BEGIN
    RAISE NOTICE \'    debut position_perso_proc\';
    SELECT niveau INTO reponse FROM Perso WHERE nom = NEW.perso;
    IF reponse IS NULL THEN
      RAISE NOTICE \'    fin check_perso_position_proc: echec\';
      RETURN NULL;
    END IF;
    RAISE NOTICE \'    fin check_perso_position_proc: reussite\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER check_perso_position_trig
  BEFORE INSERT ON Position
  FOR EACH ROW
    EXECUTE PROCEDURE check_perso_position_proc();

----------------------------------------------------------------------------------------
--              Les tables remplies et modifiees en cours de jeu                      --
----------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------
-- Structure de la table NiveauExp
--

DROP TABLE NiveauExp;
CREATE TABLE NiveauExp (
  niveau INTEGER NOT NULL,
  minExp INTEGER NOT NULL,
  maxExp INTEGER NOT NULL,
  PRIMARY KEY (niveau)
);

INSERT INTO NiveauExp VALUES (1, 0, 250);

----------------------------------------------------------------------------------------
-- Structure de la table Perso
--

DROP TABLE Perso;
CREATE TABLE Perso (
  nom TEXT NOT NULL PRIMARY KEY,
  niveau INTEGER NOT NULL default 1,
  pExperience INTEGER NOT NULL default 0,
  pVie INTEGER NOT NULL default 0,
  pVieMax INTEGER NOT NULL default 0,
  pMagie INTEGER NOT NULL default 0,
  pMagieMax INTEGER NOT NULL default 0,
  charge INTEGER NOT NULL default 0,
  chargeMax INTEGER NOT NULL default 6,
  posX INTEGER NOT NULL default 0,
  posY INTEGER NOT NULL default 0,
  bourse INTEGER NOT NULL default 0,
  metier CHAR(3) NOT NULL default 'GUE',
  race CHAR(3) NOT NULL default 'HUM',
  tir INTEGER NOT NULL default 0,
  vol INTEGER NOT NULL default 0,
  cac INTEGER NOT NULL default 0,
  dexterite INTEGER NOT NULL default 10,
  intelligence INTEGER NOT NULL default 10,
  force INTEGER NOT NULL default 10,
  endurance INTEGER NOT NULL default 10,
  vivacite INTEGER NOT NULL default 10,
  chance INTEGER NOT NULL default 10,
  pCaract INTEGER NOT NULL default 12,
  FOREIGN KEY  (metier) REFERENCES Metier 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (race) REFERENCES Race 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  CHECK (pVie >= -4),
  CHECK (pMagie >= 0),
  CHECK (charge >= 0),
  CHECK (bourse >= 0)
);

--
-- Fonctions et trigger associe  la table Perso
--

-- Verifie que le perso ne sort pas de la carte et supprime celle-ci si le perso n'existe plus
DROP FUNCTION position_perso_proc();
CREATE FUNCTION position_perso_proc() RETURNS opaque 
AS '
  DECLARE
    reponse INTEGER;
  BEGIN
    IF TG_OP = \'UPDATE\' THEN  
      -- Verifie que la position a ete modifiee
      IF NEW.posX = OLD.posX AND  NEW.posY = OLD.posY THEN
        RAISE NOTICE \'      position_perso_proc pas de changement\';
        RETURN NEW;
      END IF;
      RAISE NOTICE \'    debut position_perso_proc\';
      SELECT civilisation INTO reponse FROM Position 
      WHERE perso = NEW.nom AND posX = NEW.posX AND posY = NEW.posY;
      IF reponse IS NULL THEN
        RAISE NOTICE \'    fin position_perso_proc: echec\';
        RETURN NULL;
      END IF;
      RAISE NOTICE \'    fin position_perso_proc: reussite\';
      RETURN NEW;
    ELSE
      RAISE NOTICE \'    debut position_perso_proc\';
      DELETE FROM Position WHERE perso = OLD.nom;
      RAISE NOTICE \'    fin position_perso_proc: reussite\';
      RETURN OLD;
    END IF;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER position_perso_trig
  BEFORE UPDATE OR DELETE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE position_perso_proc();

-- Attribut automatiquement les bonus apporte par la race du perso
DROP FUNCTION bonus_race_proc();
CREATE FUNCTION bonus_race_proc() RETURNS opaque 
AS '
  DECLARE
    old_b_intelligence INTEGER := 0;
    old_b_vivacite INTEGER := 0;
    old_b_force INTEGER := 0;
    old_b_endurance INTEGER := 0;
    old_b_dexterite INTEGER := 0;
    new_b_intelligence INTEGER;
    new_b_vivacite INTEGER;
    new_b_force INTEGER;
    new_b_endurance INTEGER;
    new_b_dexterite INTEGER;
  BEGIN
    -- Verifie que la race a ete modifiee
    IF TG_OP = \'UPDATE\' THEN 
      IF NEW.race = OLD.race THEN
        RAISE NOTICE \'      bonus_race_proc pas de changement\';
        RETURN NEW;
      END IF;
    END IF;
    RAISE NOTICE \'    debut bonus_race_proc.\';
    -- Supprime les bonus de l ancienne race et ajoute ceux de la nouvelle
    IF TG_OP = \'UPDATE\' THEN
      SELECT bonusIntelligence,bonusVivacite,bonusForce,bonusEndurance,bonusDexterite 
      INTO old_b_intelligence,old_b_vivacite,old_b_force,old_b_endurance,old_b_dexterite
      FROM Race WHERE cRace = OLD.race;
    END IF;
    SELECT bonusIntelligence,bonusVivacite,bonusForce,bonusEndurance,bonusDexterite 
    INTO new_b_intelligence,new_b_vivacite,new_b_force,new_b_endurance,new_b_dexterite
    FROM Race WHERE cRace = NEW.race;
    UPDATE Perso SET intelligence = intelligence - old_b_intelligence + new_b_intelligence
    WHERE nom = NEW.nom;
    UPDATE Perso SET force = force - old_b_force + new_b_force WHERE nom = NEW.nom;
    UPDATE Perso SET endurance = endurance - old_b_endurance + new_b_endurance WHERE nom = NEW.nom;
    UPDATE Perso SET vivacite = vivacite - old_b_vivacite + new_b_vivacite WHERE nom = NEW.nom;
    UPDATE Perso SET dexterite = dexterite - old_b_dexterite + new_b_dexterite WHERE nom = NEW.nom;
    RAISE NOTICE \'    fin bonus_race_proc.\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER bonus_race_trig
  AFTER INSERT OR UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE bonus_race_proc();

-- Attribut automatiquement les bonus apporte par le metier du perso
DROP FUNCTION bonus_metier_proc();
CREATE FUNCTION bonus_metier_proc() RETURNS opaque 
AS '
  DECLARE
    old_bonus_cac INTEGER := 0;
    old_bonus_vol INTEGER := 0;
    old_bonus_tir INTEGER := 0;
    old_bonus_PM INTEGER := 0;
    old_objetA CHAR(3);
    old_objetB CHAR(3);
    new_bonus_cac INTEGER;
    new_bonus_vol INTEGER;
    new_bonus_tir INTEGER;
    new_bonus_PM INTEGER;
    new_objetA CHAR(3);
    new_objetB CHAR(3);
    cat_objetA CHAR(5);
    cat_objetB CHAR(5);
  BEGIN
    -- Verifie que la race a ete modifiee
    IF TG_OP = \'UPDATE\' THEN
      IF NEW.metier = OLD.metier THEN
        RAISE NOTICE \'      bonus_metier_proc pas de changement\';
        RETURN NEW;
      END IF;
    END IF;
    RAISE NOTICE \'    debut bonus_metier_proc.\';
    -- Supprime les bonus de l ancienne race et ajoute ceux de la nouvelle
    IF TG_OP = \'UPDATE\' THEN
      SELECT bonusCac, bonusVol, bonusTir, bonusPM, objetA, objetB
      INTO old_bonus_cac, old_bonus_vol, old_bonus_tir, old_bonus_PM, old_objetA, old_objetB
      FROM Metier WHERE cMetier = OLD.metier;
      SELECT cat INTO cat_objetA FROM CategorieObjet WHERE cObjet = old_objetA;
      SELECT cat INTO cat_objetB FROM CategorieObjet WHERE cObjet = old_objetB;
      IF cat_objetA = \'ATT_A\' OR cat_objetB = \'ATT_A\' THEN
        DELETE FROM PorterArme WHERE perso = OLD.nom;
      END IF;
      IF cat_objetA = \'DEF_A\' OR cat_objetB = \'DEF_A\' THEN
        DELETE FROM PorterArmure WHERE perso = OLD.nom;
      END IF;
      IF cat_objetA = \'DEF_B\' OR cat_objetB = \'DEF_B\' THEN
        DELETE FROM PorterBouclier WHERE perso = OLD.nom;
      END IF;
      IF cat_objetA = \'DEF_C\' OR cat_objetB = \'DEF_C\' THEN
        DELETE FROM PorterCasque WHERE perso = OLD.nom;
      END IF;
      IF cat_objetA = \'DIV_P\' OR cat_objetB = \'DIV_P\' THEN
        DELETE FROM PorterPotion WHERE perso = OLD.nom;
      END IF;
      IF cat_objetA = \'DIV_L\' OR cat_objetB = \'DIV_L\' THEN
        DELETE FROM PorterLivre WHERE perso = OLD.nom;
      END IF;
    END IF;
    SELECT bonusCac, bonusVol, bonusTir, bonusPM, objetA, objetB
    INTO new_bonus_cac, new_bonus_vol, new_bonus_tir, new_bonus_PM, new_objetA, new_objetB
    FROM Metier WHERE cMetier = NEW.metier;
    UPDATE Perso SET tir = tir - old_bonus_tir + new_bonus_tir WHERE nom = NEW.nom;
    UPDATE Perso SET vol = vol - old_bonus_vol + new_bonus_vol WHERE nom = NEW.nom;
    UPDATE Perso SET cac = cac - old_bonus_cac + new_bonus_cac WHERE nom = NEW.nom;
    UPDATE Perso SET pMagieMax = pMagieMax - old_bonus_PM + new_bonus_PM WHERE nom = NEW.nom;
    UPDATE Perso SET pMagie = pMagie - old_bonus_PM + new_bonus_PM WHERE nom = NEW.nom;
    SELECT cat INTO cat_objetA FROM CategorieObjet WHERE cObjet = new_objetA;
    SELECT cat INTO cat_objetB FROM CategorieObjet WHERE cObjet = new_objetB;
    IF cat_objetA = \'ATT_A\' THEN
      INSERT INTO PorterArme VALUES (NEW.nom, new_objetA, 0, 0);
    ELSIF cat_objetA = \'DEF_A\' THEN
      INSERT INTO PorterArmure VALUES (NEW.nom, new_objetA, 0, 0);
    ELSIF cat_objetA = \'DEF_B\' THEN
      INSERT INTO PorterBouclier VALUES (NEW.nom, new_objetA, 0, 0);
    ELSIF cat_objetA = \'DEF_C\' THEN
      INSERT INTO PorterCasque VALUES (NEW.nom, new_objetA, 0, 0);
    ELSIF cat_objetA = \'DIV_P\' THEN
      INSERT INTO PorterPotion VALUES (NEW.nom, new_objetA);
    ELSIF cat_objetA = \'DIV_L\' THEN
      INSERT INTO PorterLivre VALUES (NEW.nom, new_objetA);
    END IF;
    IF cat_objetB = \'ATT_A\' THEN
      INSERT INTO PorterArme VALUES (NEW.nom, new_objetB, 0, 0);
    ELSIF cat_objetB = \'DEF_A\' THEN
      INSERT INTO PorterArme VALUES (NEW.nom, new_objetB, 0, 0);
    ELSIF cat_objetB = \'DEF_B\' THEN
      INSERT INTO PorterBouclier VALUES (NEW.nom, new_objetB, 0, 0);
    ELSIF cat_objetB = \'DEF_C\' THEN
      INSERT INTO PorterCasque VALUES (NEW.nom, new_objetB, 0, 0);
    ELSIF cat_objetB = \'DIV_P\' THEN
      INSERT INTO PorterPotion VALUES (NEW.nom, new_objetB);
    ELSIF cat_objetB = \'DIV_L\' THEN
      INSERT INTO PorterLivre VALUES (NEW.nom, new_objetB);
    END IF;
    RAISE NOTICE \'    fin bonus_metier_proc\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER bonus_metier_trig
  AFTER INSERT OR UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE bonus_metier_proc();

-- Les points d'experience permettent de passer  un niv superieur (automatise le processus)
DROP FUNCTION experience_proc();
CREATE FUNCTION experience_proc() RETURNS opaque 
AS '
  DECLARE
    p_exp_max INTEGER;
    next_niv INTEGER;
  BEGIN
    -- Verifie que les points d exp ont augmente
    IF NEW.pExperience = OLD.pExperience THEN
      RETURN NEW;
    ELSIF NEW.pExperience < OLD.pExperience THEN
      RAISE NOTICE \'Impossible de decrementer les points d experience.\';
      RETURN NULL;
    END IF;
    RAISE NOTICE \'    debut experience_proc\';
    SELECT maxExp INTO p_exp_max FROM NiveauExp WHERE niveau = OLD.niveau;
    IF NEW.pExperience > p_exp_max THEN
      -- Rajoute ds la table NiveauExp une entree definissant le nouveau niveau
      SELECT niveau INTO next_niv FROM NiveauExp WHERE niveau = OLD.niveau + 1;
      IF next_niv IS NULL THEN
        INSERT INTO NiveauExp 
        VALUES (OLD.niveau + 1, p_exp_max + 1, p_exp_max + 250*(2^OLD.niveau));
        RAISE NOTICE \'        experience_proc : creation d un nouveau niv\';
      END IF;
      -- Augmnte le niveau du perso
      UPDATE Perso SET niveau = niveau + 1 WHERE nom = NEW.nom;
      RAISE NOTICE \'        experience_proc : augmente niv du perso\';
    END IF;
    RAISE NOTICE \'    fin experience_proc\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER experience_trig
  AFTER UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE experience_proc();

-- Bonus pour chaque niveau d'experience gagne
DROP FUNCTION niveau_proc();
CREATE FUNCTION niveau_proc() RETURNS opaque 
AS '
  DECLARE
    p_exp_max INTEGER;
  BEGIN
    -- Verifie que le niveau a augmente
    IF NEW.niveau = OLD.niveau THEN
      RETURN NEW;
    ELSIF NEW.niveau < OLD.niveau THEN
      RAISE NOTICE \'Impossible de diminuer le niveau d un perso\';
      RETURN NULL;
    END IF;
    RAISE NOTICE \'    debut niveau_proc\';
    -- Augmente les points de vie et de magie
    UPDATE Perso SET pVieMax = pVieMax + 10 WHERE nom = NEW.nom;
    UPDATE Perso SET pVie = pVieMax WHERE nom = NEW.nom;
    UPDATE Perso SET pMagieMax = pMagieMax + 10 WHERE nom = NEW.nom;
    UPDATE Perso SET pMagie = pMagieMax WHERE nom = NEW.nom;
    -- Augmente la charge max
    UPDATE Perso SET chargeMax = chargeMax + 8 WHERE nom = NEW.nom;
    -- Augmente les caracteristiques
    UPDATE Perso SET pCaract = pCaract + 10 WHERE nom = NEW.nom;
    RAISE NOTICE \'    fin niveau_proc\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER niveau_trig
  AFTER UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE niveau_proc();

-- La dexterite determine les valeurs des attributs vol, tir et cac
DROP FUNCTION dexterite_proc();
CREATE FUNCTION dexterite_proc() RETURNS opaque 
AS '
  BEGIN
    -- Verifie que la dexterite a change
    IF TG_OP = \'UPDATE\' THEN
      IF NEW.dexterite = OLD.dexterite THEN
        RAISE NOTICE \'      dexterite_proc pas de changement\';
        RETURN NEW;
      END IF;
    END IF;
    RAISE NOTICE \'    debut dexterite_proc\';
    IF TG_OP = \'UPDATE\' THEN
      -- Modifie la competence corps a corps (cac=dexterite+force)
      UPDATE Perso SET cac = cac + NEW.dexterite - OLD.dexterite WHERE nom = NEW.nom;
      -- Modifie la competence tir a l arc (tir=dexterite+vivacite)
      UPDATE Perso SET tir = tir + NEW.dexterite - OLD.dexterite WHERE nom = NEW.nom;
      -- Modifie la competence vol (vol=dexterite+chance)
      UPDATE Perso SET vol = vol + NEW.dexterite - OLD.dexterite WHERE nom = NEW.nom;
    ELSE
      -- Modifie la competence corps a corps (cac=dexterite+force)
      UPDATE Perso SET cac = cac + NEW.dexterite WHERE nom = NEW.nom;
      -- Modifie la competence tir a l arc (tir=dexterite+vivacite)
      UPDATE Perso SET tir = tir + NEW.dexterite WHERE nom = NEW.nom;
      -- Modifie la competence vol (vol=dexterite+chance)
      UPDATE Perso SET vol = vol + NEW.dexterite WHERE nom = NEW.nom;      
    END IF;
    RAISE NOTICE \'    fin dexterite_proc\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER dexterite_trig
  AFTER INSERT OR UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE dexterite_proc();

-- L'endurance determine pVieMax et chargeMax
DROP FUNCTION endurance_proc();
CREATE FUNCTION endurance_proc() RETURNS opaque 
AS '
  BEGIN
    -- Verifie que la endurance a change
    IF TG_OP = \'UPDATE\' THEN
      IF NEW.endurance = OLD.endurance THEN
        RAISE NOTICE \'      endurance_proc pas de changement\';
        RETURN NEW;
      END IF;
    END IF;
    RAISE NOTICE \'    debut endurance_proc\';
    IF TG_OP = \'UPDATE\' THEN
      -- Modifie le nb max de point de vie (pVieMax=2*endurance+bonus...)
      UPDATE Perso SET pVieMax = pVieMax + 2 * (NEW.endurance -OLD.endurance) WHERE nom = NEW.nom;
      UPDATE Perso SET pVie = pVie + 2 * (NEW.endurance - OLD.endurance) WHERE nom = NEW.nom;
      -- Modifie la charge max (chargeMax=6+endurance+force+bonus...)
      UPDATE Perso SET chargeMax = chargeMax + (NEW.endurance -OLD.endurance) WHERE nom = NEW.nom;
    ELSE
      -- Modifie le nb max de point de vie (pVieMax=2*endurance+bonus...)
      UPDATE Perso SET pVieMax = pVieMax + 2 * NEW.endurance WHERE nom = NEW.nom;
      UPDATE Perso SET pVie = pVie + 2 * NEW.endurance WHERE nom = NEW.nom;
      -- Modifie la charge max (chargeMax=6+endurance+force+bonus...)
      UPDATE Perso SET chargeMax = chargeMax + NEW.endurance WHERE nom = NEW.nom;
    END IF;
    RAISE NOTICE \'    fin endurance_proc\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER endurance_trig
  AFTER INSERT OR UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE endurance_proc();

-- L'intelligence determine pMagieMax
DROP FUNCTION intelligence_proc();
CREATE FUNCTION intelligence_proc() RETURNS opaque 
AS '
  BEGIN
    -- Verifie que la intelligence a change
    IF TG_OP = \'UPDATE\' THEN
      IF NEW.intelligence = OLD.intelligence THEN
        RAISE NOTICE \'      intelligence_proc pas de changement\';
        RETURN NEW;
      END IF;
    END IF;
    RAISE NOTICE \'    debut intelligence_proc\';
    IF TG_OP = \'UPDATE\' THEN
      -- Modifie le nb max de point de magie (pMagieMax=2*intelligence+bonus...)
      UPDATE Perso SET pMagie = pMagie + 2 * (NEW.intelligence - OLD.intelligence) 
      WHERE nom = OLD.nom;
      UPDATE Perso SET pMagieMax = pMagieMax + 2 * (NEW.intelligence - OLD.intelligence) 
      WHERE nom = OLD.nom;
    ELSE
      -- Modifie le nb max de point de magie (pMagieMax=2*intelligence+bonus...)
      UPDATE Perso SET pMagieMax = 2 * NEW.intelligence WHERE nom = NEW.nom;
      UPDATE Perso SET pMagie = 2 * NEW.intelligence WHERE nom = NEW.nom;
    END IF;
    RAISE NOTICE \'    fin intelligence_proc\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER intelligence_trig
  AFTER INSERT OR UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE intelligence_proc();

-- La chance determine vol 
DROP FUNCTION chance_proc();
CREATE FUNCTION chance_proc() RETURNS opaque 
AS '
  BEGIN
    -- Verifie que la chance a change
    IF TG_OP = \'UPDATE\' THEN
      IF NEW.chance = OLD.chance THEN
        RAISE NOTICE \'      chance_proc pas de changement\';
        RETURN NEW;
      END IF;
    END IF;
    RAISE NOTICE \'    debut chance_proc\';
    IF TG_OP = \'UPDATE\' THEN
      -- Modifie la competence vol (vol=dexterite+chance)
      UPDATE Perso SET vol = vol + NEW.chance - OLD.chance WHERE nom = NEW.nom;
    ELSE
      -- Modifie la competence vol (vol=dexterite+chance)
      UPDATE Perso SET vol = vol + NEW.chance WHERE nom = NEW.nom;
    END IF;
    RAISE NOTICE \'    fin chance_proc\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER chance_trig
  AFTER INSERT OR UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE chance_proc();

-- La vivacite determine tir 
DROP FUNCTION vivacite_proc();
CREATE FUNCTION vivacite_proc() RETURNS opaque 
AS '
  BEGIN
    -- Verifie que la vivacite a change
    IF TG_OP = \'UPDATE\' THEN
      IF NEW.vivacite = OLD.vivacite THEN
        RAISE NOTICE \'      vivacite_proc pas de changement\';
        RETURN NEW;
      END IF;
    END IF;
    RAISE NOTICE \'    debut vivacite_proc\';
    IF TG_OP = \'UPDATE\' THEN
      -- Modifie la competence tir (tir=dexterite+vivacite)
      UPDATE Perso SET tir = tir + NEW.vivacite - OLD.vivacite WHERE nom = NEW.nom;
    ELSE
      -- Modifie la competence tir (tir=dexterite+vivacite)
      UPDATE Perso SET tir = tir + NEW.vivacite WHERE nom = NEW.nom;
    END IF;
    RAISE NOTICE \'    fin vivacite_proc\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER vivacite_trig
  AFTER INSERT OR UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE vivacite_proc();

-- La force determine cac 
DROP FUNCTION force_proc();
CREATE FUNCTION force_proc() RETURNS opaque 
AS '
  BEGIN
    -- Verifie que la force a change
    IF TG_OP = \'UPDATE\' THEN
      IF NEW.force = OLD.force THEN
        RAISE NOTICE \'      force_proc pas de changement\';
        RETURN NEW;
      END IF;
    END IF;
    RAISE NOTICE \'    debut force_proc\';
    IF TG_OP = \'UPDATE\' THEN
      -- Modifie la competence corps a corps (cac=dexterite+force)
      UPDATE Perso SET cac = cac + NEW.force - OLD.force WHERE nom = NEW.nom;
      -- Modifie la charge max (chargeMax=6+endurance+force+bonus...)
      UPDATE Perso SET chargeMax = chargeMax + (NEW.force - OLD.force) WHERE nom = NEW.nom;
    ELSE
      -- Modifie la competence corps a corps (cac=dexterite+force)
      UPDATE Perso SET cac = cac + NEW.force WHERE nom = NEW.nom;
      -- Modifie la charge max (chargeMax=6+endurance+force+bonus...)
      UPDATE Perso SET chargeMax = chargeMax + NEW.force WHERE nom = NEW.nom;
    END IF;
    RAISE NOTICE \'    fin force_proc\';
    RETURN NEW;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER force_trig
  AFTER INSERT OR UPDATE ON Perso
  FOR EACH ROW
    EXECUTE PROCEDURE force_proc();

----------------------------------------------------------------------------------------
-- Structure de la table PorterArme
--

DROP SEQUENCE PorterArme_id_seq;
DROP TABLE PorterArme;
CREATE TABLE PorterArme (
  perso TEXT NOT NULL,
  cObjet CHAR(3) NOT NULL,
  usure DECIMAL(5,2) NOT NULL default 0,
  surSoi INTEGER NOT NULL default 0,
  id SERIAL, -- type auto-incremental 
  FOREIGN KEY  (perso) REFERENCES Perso 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (cObjet) REFERENCES Arme 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Fonctions et trigger associe  la table Arme
--

-- Met  jour la charge d'un joueur lorsqu'il acquiert un nouvel objet 
DROP FUNCTION charge_add_proc();
CREATE FUNCTION charge_add_proc() RETURNS opaque 
AS '
  DECLARE
    new_charge INTEGER;
    old_charge INTEGER;
    max_charge INTEGER;
    poids_objet INTEGER;
  BEGIN
    RAISE NOTICE \'    debut charge_add_proc\';
    SELECT charge, chargeMax INTO old_charge, max_charge FROM Perso WHERE nom = NEW.perso;
    IF TG_ARGV[0] = \'Arme\' THEN
      SELECT poids INTO poids_objet FROM Arme WHERE cArme = NEW.cObjet;
    ELSIF TG_ARGV[0] = \'Armure\' THEN
      SELECT poids INTO poids_objet FROM Armure WHERE cArmure = NEW.cObjet;
    ELSIF TG_ARGV[0] = \'Casque\' THEN
      SELECT poids INTO poids_objet FROM Casque WHERE cCasque = NEW.cObjet;
    ELSIF TG_ARGV[0] = \'Bouclier\' THEN
      SELECT poids INTO poids_objet FROM Bouclier WHERE cBouclier = NEW.cObjet;
    ELSIF TG_ARGV[0] = \'Potion\' THEN
      SELECT poids INTO poids_objet FROM Potion WHERE cPotion = NEW.cObjet;
    ELSIF TG_ARGV[0] = \'Livre\' THEN
      SELECT poids INTO poids_objet FROM Livre WHERE cLivre = NEW.cObjet;
    END IF;
    new_charge := old_charge + poids_objet;
    IF new_charge > max_charge THEN
      RAISE NOTICE \'    fin charge_add_proc: surcharge\';
      RETURN NULL;
    ELSE
      UPDATE Perso SET charge = new_charge WHERE nom = NEW.perso;
      RAISE NOTICE \'    fin charge_add_proc: ajout ok\';
      RETURN NEW;
    END IF;
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER charge_add_arme_trig
  BEFORE INSERT ON PorterArme
  FOR EACH ROW
  EXECUTE PROCEDURE charge_add_proc('Arme');

-- Met  jour la charge d'un joueur lorsqu'il jette ou vend un objet 
DROP FUNCTION charge_del_proc();
CREATE FUNCTION charge_del_proc() RETURNS opaque 
AS '
  DECLARE
    poids_objet INTEGER;
  BEGIN
    RAISE NOTICE \'    debut charge_del_proc\';
    IF TG_ARGV[0] = \'Arme\' THEN
      SELECT poids INTO poids_objet FROM Arme WHERE cArme = OLD.cObjet;
    ELSIF TG_ARGV[0] = \'Armure\' THEN
      SELECT poids INTO poids_objet FROM Armure WHERE cArmure = OLD.cObjet;
    ELSIF TG_ARGV[0] = \'Casque\' THEN
      SELECT poids INTO poids_objet FROM Casque WHERE cCasque = OLD.cObjet;
    ELSIF TG_ARGV[0] = \'Bouclier\' THEN
      SELECT poids INTO poids_objet FROM Bouclier WHERE cBouclier = OLD.cObjet;
    ELSIF TG_ARGV[0] = \'Potion\' THEN
      SELECT poids INTO poids_objet FROM Potion WHERE cPotion = OLD.cObjet;
    ELSIF TG_ARGV[0] = \'Livre\' THEN
      SELECT poids INTO poids_objet FROM Livre WHERE cLivre = OLD.cObjet;
    END IF;
    UPDATE Perso SET charge = charge - poids_objet WHERE nom = OLD.perso;
    RAISE NOTICE \'    fin charge_del_proc\';
    RETURN OLD; 
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER charge_del_arme_trig
  AFTER DELETE ON PorterArme
  FOR EACH ROW
  EXECUTE PROCEDURE charge_del_proc('Arme');

-- Un joueur ne peut avoir 2 armes en main ni une arme  2 mains avec un bouclier 
DROP FUNCTION select_arme_proc();
CREATE FUNCTION select_arme_proc() RETURNS opaque 
AS '
  DECLARE
    categorie_arme INTEGER;
  BEGIN
    IF NEW.surSoi = 0 OR NEW.surSoi = OLD.surSoi THEN
      RETURN NEW;
    END IF;
    RAISE NOTICE \'    debut select_arme_proc\';
    UPDATE PorterArme SET surSoi = 0 WHERE surSoi = 1 AND perso = NEW.perso;
    SELECT categorie INTO categorie_arme FROM Arme WHERE cArme = NEW.cObjet;
    IF categorie_arme = 1 THEN
      RETURN NEW;
    END IF;
    UPDATE PorterBouclier SET surSoi = 0 WHERE surSoi = 1 AND perso = NEW.perso;
    RAISE NOTICE \'    fin select_arme_proc\';
    RETURN NEW; 
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER select_arme_trig
  BEFORE UPDATE ON PorterArme
  FOR EACH ROW
  EXECUTE PROCEDURE select_arme_proc();

-- Verifie que si un objet ne se casse pas et le supprime de la liste ds ce cas. 
DROP FUNCTION usure_proc();
CREATE FUNCTION usure_proc() RETURNS opaque 
AS '
  DECLARE
    solidite_objet INTEGER;
  BEGIN
    RAISE NOTICE \'    debut usure_proc\';
    IF NEW.usure <= OLD.usure THEN
      RETURN NEW; -- Le champ usure n a apas ete modifie
    END IF;
    IF TG_ARGV[0] = \'Arme\' THEN
      SELECT solidite INTO solidite_objet FROM Arme WHERE cArme = NEW.cObjet;
    ELSIF TG_ARGV[0] = \'Armure\' THEN
      SELECT solidite INTO solidite_objet FROM Armure WHERE cArmure = NEW.cObjet;
    ELSIF TG_ARGV[0] = \'Casque\' THEN
      SELECT solidite INTO solidite_objet FROM Casque WHERE cCasque = NEW.cObjet;
    ELSIF TG_ARGV[0] = \'Bouclier\' THEN
      SELECT solidite INTO solidite_objet FROM Bouclier WHERE cBouclier = NEW.cObjet;
    END IF;
    IF NEW.usure >= solidite_objet THEN
      -- Objet casse
      RAISE NOTICE \'      usure_proc : objet casse\';
      IF TG_ARGV[0] = \'Arme\' THEN
        DELETE FROM PorterArme WHERE id = NEW.id;
      ELSIF TG_ARGV[0] = \'Armure\' THEN
        DELETE FROM PorterArmure WHERE id = NEW.id;
      ELSIF TG_ARGV[0] = \'Casque\' THEN
        DELETE FROM PorterCasque WHERE id = NEW.id;
      ELSIF TG_ARGV[0] = \'Bouclier\' THEN
        DELETE FROM PorterBouclier WHERE id = NEW.id;
      END IF;
    END IF;
    RAISE NOTICE \'    fin usure_proc\';
    RETURN NEW; 
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER usure_arme_trig
  AFTER UPDATE ON PorterArme
  FOR EACH ROW
  EXECUTE PROCEDURE usure_proc('Arme');

----------------------------------------------------------------------------------------
-- Structure de la table PorterArmure
--

DROP SEQUENCE PorterArmure_id_seq;
DROP TABLE PorterArmure;
CREATE TABLE PorterArmure (
  perso TEXT NOT NULL,
  cObjet CHAR(3) NOT NULL,
  usure DECIMAL(5,2) NOT NULL default 0,
  surSoi INTEGER NOT NULL default 0,
  id SERIAL, -- type auto-incremental 
  FOREIGN KEY  (perso) REFERENCES Perso 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (cObjet) REFERENCES Armure 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Fonctions et trigger associe  la table PorterArmure
--

-- Met a jour la charge d'un joueur lorsqu'il acquiert un nouvel objet 
CREATE TRIGGER charge_add_armure_trig
  BEFORE INSERT ON PorterArmure
  FOR EACH ROW
  EXECUTE PROCEDURE charge_add_proc('Armure');

-- Met a jour la charge d'un joueur lorsqu'il jette ou vend un objet 
CREATE TRIGGER charge_del_armure_trig
  AFTER DELETE ON PorterArmure
  FOR EACH ROW
  EXECUTE PROCEDURE charge_del_proc('Armure');

-- Un joueur ne peut porter 2 armures 
DROP FUNCTION select_armure_proc();
CREATE FUNCTION select_armure_proc() RETURNS opaque 
AS '
  BEGIN
    IF NEW.surSoi = 1 AND OLD.surSoi = 0 THEN
      RAISE NOTICE \'    debut select_armure_proc\';
      UPDATE PorterArmure SET surSoi = 0 WHERE surSoi = 1 AND perso = NEW.perso;
      RAISE NOTICE \'    fin select_armure_proc\';
    END IF;
    RETURN NEW; 
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER select_armure_trig
  BEFORE UPDATE ON PorterArmure
  FOR EACH ROW
  EXECUTE PROCEDURE select_armure_proc();

-- Verifie que si un objet ne se casse pas et le supprime de la liste ds ce cas. 
CREATE TRIGGER usure_armure_trig
  AFTER UPDATE ON PorterArmure
  FOR EACH ROW
  EXECUTE PROCEDURE usure_proc('Armure');

----------------------------------------------------------------------------------------
-- Structure de la table PorterBouclier
--

DROP SEQUENCE PorterBouclier_id_seq;
DROP TABLE PorterBouclier;
CREATE TABLE PorterBouclier (
  perso TEXT NOT NULL,
  cObjet CHAR(3) NOT NULL,
  usure DECIMAL(5,2) NOT NULL default 0,
  surSoi INTEGER NOT NULL default 0,
  id SERIAL, -- type auto-incremental 
  FOREIGN KEY  (perso) REFERENCES Perso 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (cObjet) REFERENCES Bouclier 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Fonctions et trigger associe  la table PorterBouclier
--

-- Met a jour la charge d'un joueur lorsqu'il acquiert un nouvel objet 
CREATE TRIGGER charge_add_bouclier
  BEFORE INSERT ON PorterBouclier
  FOR EACH ROW
  EXECUTE PROCEDURE charge_add_proc('Bouclier');

-- Met a jour la charge d'un joueur lorsqu'il jette ou vend un objet 
CREATE TRIGGER charge_del_bouclier_trig
  AFTER DELETE ON PorterBouclier
  FOR EACH ROW
  EXECUTE PROCEDURE charge_del_proc('Bouclier');

-- Un joueur ne peut voir en main une arme  2 mains avec un bouclier 
DROP FUNCTION select_bouclier_proc();
CREATE FUNCTION select_bouclier_proc() RETURNS opaque 
AS '
  DECLARE
    categorie_arme INTEGER;
    arme_en_main CHAR(3);
  BEGIN
    IF NEW.surSoi = 0 OR NEW.surSoi = OLD.surSoi THEN
      RETURN NEW;
    END IF;
    RAISE NOTICE \'    debut select_bouclier_proc\';
    UPDATE PorterBouclier SET surSoi = 0 WHERE surSoi = 1 AND perso = NEW.perso;
    SELECT cObjet INTO arme_en_main FROM PorterArme WHERE surSoi = 1;
    IF arme_en_main = NULL THEN
      RETURN NEW;
    END IF;
    SELECT categorie INTO categorie_arme FROM Arme WHERE cArme = arme_en_main;
    IF categorie_arme = 1 THEN
      RETURN NEW;
    END IF;
    UPDATE PorterArme SET surSoi = 0 WHERE surSoi = 1 AND perso = NEW.perso;
    RAISE NOTICE \'    fin select_bouclier_proc\';
    RETURN NEW; 
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER select_bouclier_trig
  BEFORE UPDATE ON PorterBouclier
  FOR EACH ROW
  EXECUTE PROCEDURE select_bouclier_proc();

-- Verifie que si un objet ne se casse pas et le supprime de la liste ds ce cas. 
CREATE TRIGGER usure_bouclier_trig
  AFTER UPDATE ON PorterBouclier
  FOR EACH ROW
  EXECUTE PROCEDURE usure_proc('Bouclier');

----------------------------------------------------------------------------------------
-- Structure de la table PorterCasque
--

DROP SEQUENCE PorterCasque_id_seq;
DROP TABLE PorterCasque;
CREATE TABLE PorterCasque (
  perso TEXT NOT NULL,
  cObjet CHAR(3) NOT NULL,
  usure DECIMAL(5,2) NOT NULL default 0,
  surSoi INTEGER NOT NULL default 0,
  id SERIAL, -- type auto-incremental 
  FOREIGN KEY  (perso) REFERENCES Perso 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (cObjet) REFERENCES Casque 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Fonctions et trigger associe  la table PorterCasque
--

-- Met a jour la charge d'un joueur lorsqu'il acquiert un nouvel objet 
CREATE TRIGGER charge_add_casque
  BEFORE INSERT ON PorterCasque
  FOR EACH ROW
  EXECUTE PROCEDURE charge_add_proc('Casque');

-- Met a jour la charge d'un joueur lorsqu'il jette ou vend un objet 
CREATE TRIGGER charge_del_casque_trig
  AFTER DELETE ON PorterCasque
  FOR EACH ROW
  EXECUTE PROCEDURE charge_del_proc('Casque');

-- Un joueur ne peut porter 2 casques en meme temps 
DROP FUNCTION select_casque_proc();
CREATE FUNCTION select_casque_proc() RETURNS opaque 
AS '
  BEGIN
    IF NEW.surSoi = 1 AND OLD.surSoi = 0 THEN
      RAISE NOTICE \'    debut select_casque_proc\';
      UPDATE PorterCasque SET surSoi = 0 WHERE surSoi = 1 AND perso = NEW.perso;
      RAISE NOTICE \'    fin select_casque_proc\';
    END IF;
    RETURN NEW; 
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER select_casque_trig
  BEFORE UPDATE ON PorterCasque
  FOR EACH ROW
  EXECUTE PROCEDURE select_casque_proc();

-- Verifie que si un objet ne se casse pas et le supprime de la liste ds ce cas. 
CREATE TRIGGER usure_casque_trig
  AFTER UPDATE ON PorterCasque
  FOR EACH ROW
  EXECUTE PROCEDURE usure_proc('Casque');

----------------------------------------------------------------------------------------
-- Structure de la table PorterPotion
--

DROP SEQUENCE PorterPotion_id_seq;
DROP TABLE PorterPotion;
CREATE TABLE PorterPotion (
  perso TEXT NOT NULL,
  cObjet CHAR(3) NOT NULL,
  id SERIAL, -- type auto-incremental 
  FOREIGN KEY  (perso) REFERENCES Perso 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (cObjet) REFERENCES Potion
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Fonctions et trigger associe  la table PorterPotion
--

-- Met a jour la charge d'un joueur lorsqu'il acquiert un nouvel objet 
CREATE TRIGGER charge_add_potion_trig
  BEFORE INSERT ON PorterPotion
  FOR EACH ROW
  EXECUTE PROCEDURE charge_add_proc('Potion');

-- Met a jour la charge d'un joueur lorsqu'il jette ou vend un objet 
CREATE TRIGGER charge_del_potion_trig
  AFTER DELETE ON PorterPotion
  FOR EACH ROW
  EXECUTE PROCEDURE charge_del_proc('Potion');

----------------------------------------------------------------------------------------
-- Structure de la table PorterLivre
--

DROP SEQUENCE PorterLivre_id_seq;
DROP TABLE PorterLivre;
CREATE TABLE PorterLivre (
  perso TEXT NOT NULL,
  cObjet CHAR(3) NOT NULL,
  id SERIAL, -- type auto-incremental 
  FOREIGN KEY  (perso) REFERENCES Perso 
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY  (cObjet) REFERENCES Livre
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Fonctions et trigger associe  la table PorterLivre
--

-- Met a jour la charge d'un joueur lorsqu'il acquiert un nouvel objet 
CREATE TRIGGER charge_add_livre_trig
  BEFORE INSERT ON PorterLivre
  FOR EACH ROW
  EXECUTE PROCEDURE charge_add_proc('Livre');

-- Met a jour la charge d'un joueur lorsqu'il jette ou vend un objet 
CREATE TRIGGER charge_del_livre_trig
  AFTER DELETE ON PorterLivre
  FOR EACH ROW
  EXECUTE PROCEDURE charge_del_proc('Livre');

----------------------------------------------------------------------------------------
-- Structure de la table ConnaitreSort
--

DROP TABLE ConnaitreSort;
CREATE TABLE ConnaitreSort (
  perso TEXT NOT NULL,
  cSort CHAR(3) NOT NULL,
  nivMax INTEGER NOT NULL default 1,
  PRIMARY KEY (perso,cSort),
  FOREIGN KEY  (perso) REFERENCES Perso 
    ON UPDATE CASCADE
    ON DELETE CASCADE ,
  FOREIGN KEY  (cSort,nivMax) REFERENCES Sort
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

--
-- Fonctions et trigger associe  la table ConnaitreSort
--

-- La progression des sorts est continue : on ne peut sauter un niveau 
DROP FUNCTION progres_sort_proc();
CREATE FUNCTION progres_sort_proc() RETURNS opaque 
AS '
  BEGIN
    IF TG_OP = \'UPDATE\' THEN
      IF NEW.nivMax = OLD.nivMax OR NEW.nivMax = OLD.nivMax+1 THEN
        RETURN NEW;
      END IF;
    ELSE
      IF NEW.nivMax = 1 THEN
        RETURN NEW;
      END IF;
    END IF;
    RETURN NULL; 
  END;
'
LANGUAGE 'plpgsql';

CREATE TRIGGER progres_sort_trig
  BEFORE UPDATE OR INSERT ON ConnaitreSort
  FOR EACH ROW
  EXECUTE PROCEDURE progres_sort_proc();

----------------------------------------------------------------------------------------
-- Structure de la table Marchand
--

DROP TABLE Marchand;
CREATE TABLE  Marchand(
  perso TEXT NOT NULL,
  cObjet CHAR(3) NOT NULL,
  categorie CHAR(5) NOT NULL,
  quantite INTEGER NOT NULL default 1,
  UNIQUE (perso,cObjet),
  FOREIGN KEY  (perso) REFERENCES Perso 
    ON UPDATE CASCADE
    ON DELETE CASCADE
);